"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Spinner = exports.CLI = exports.run = exports.withRNVMetro = exports.withRNVBabel = exports.Utils = exports.Resolver = exports.NPMUtils = exports.Logger = exports.Config = exports.Doctor = exports.ObjectUtils = exports.FileUtils = exports.Exec = exports.RuntimeManager = exports.TaskManager = exports.TemplateManager = exports.SDKManager = exports.SchemaManager = exports.ConfigManager = exports.ProjectManager = exports.PluginManager = exports.SetupManager = exports.PlatformManager = exports.EngineManager = exports.Prompt = exports.Common = exports.Constants = exports.doResolvePath = exports.doResolve = exports.initializeBuilder = void 0;
var tslib_1 = require("tslib");
require("regenerator-runtime/runtime");
var Common = tslib_1.__importStar(require("./core/common"));
exports.Common = Common;
var Utils = tslib_1.__importStar(require("./core/systemManager/utils"));
exports.Utils = Utils;
var Prompt = tslib_1.__importStar(require("./cli/prompt"));
exports.Prompt = Prompt;
var Constants = tslib_1.__importStar(require("./core/constants"));
exports.Constants = Constants;
var ora_1 = tslib_1.__importDefault(require("./cli/ora"));
exports.Spinner = ora_1.default;
var adapter_1 = require("./core/adapter");
Object.defineProperty(exports, "withRNVBabel", { enumerable: true, get: function () { return adapter_1.withRNVBabel; } });
Object.defineProperty(exports, "withRNVMetro", { enumerable: true, get: function () { return adapter_1.withRNVMetro; } });
var cli_1 = tslib_1.__importDefault(require("./cli"));
exports.CLI = cli_1.default;
require("source-map-support/register");
// MANAGERS
var EngineManager = tslib_1.__importStar(require("./core/engineManager"));
exports.EngineManager = EngineManager;
var SetupManager = tslib_1.__importStar(require("./core/setupManager"));
exports.SetupManager = SetupManager;
var PlatformManager = tslib_1.__importStar(require("./core/platformManager"));
exports.PlatformManager = PlatformManager;
var PluginManager = tslib_1.__importStar(require("./core/pluginManager"));
exports.PluginManager = PluginManager;
var ProjectManager = tslib_1.__importStar(require("./core/projectManager"));
exports.ProjectManager = ProjectManager;
var ConfigManager = tslib_1.__importStar(require("./core/configManager"));
exports.ConfigManager = ConfigManager;
var SchemaManager = tslib_1.__importStar(require("./core/schemaManager"));
exports.SchemaManager = SchemaManager;
var RuntimeManager = tslib_1.__importStar(require("./core/runtimeManager"));
exports.RuntimeManager = RuntimeManager;
var SDKManager = tslib_1.__importStar(require("./core/sdkManager"));
exports.SDKManager = SDKManager;
var TemplateManager = tslib_1.__importStar(require("./core/templateManager"));
exports.TemplateManager = TemplateManager;
var TaskManager = tslib_1.__importStar(require("./core/taskManager"));
exports.TaskManager = TaskManager;
// SUB-MODULES
var NPMUtils = tslib_1.__importStar(require("./core/systemManager/npmUtils"));
exports.NPMUtils = NPMUtils;
var ObjectUtils = tslib_1.__importStar(require("./core/systemManager/objectUtils"));
exports.ObjectUtils = ObjectUtils;
var Exec = tslib_1.__importStar(require("./core/systemManager/exec"));
exports.Exec = Exec;
var FileUtils = tslib_1.__importStar(require("./core/systemManager/fileutils"));
exports.FileUtils = FileUtils;
var Doctor = tslib_1.__importStar(require("./core/systemManager/doctor"));
exports.Doctor = Doctor;
var Logger = tslib_1.__importStar(require("./core/systemManager/logger"));
exports.Logger = Logger;
var Resolver = tslib_1.__importStar(require("./core/systemManager/resolve"));
exports.Resolver = Resolver;
var analytics_1 = tslib_1.__importDefault(require("./core/systemManager/analytics"));
var config_1 = tslib_1.__importDefault(require("./core/configManager/config"));
exports.Config = config_1.default;
global.RNV_ANALYTICS = analytics_1.default;
var initializeBuilder = function (cmd, subCmd, process, program) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var c, _a;
    return tslib_1.__generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                // set mono and ci if json is enabled
                if (program.json) {
                    program.mono = true;
                    program.ci = true;
                }
                analytics_1.default.initialize();
                FileUtils.configureFilesystem(Common.getConfigProp, Resolver.doResolve, Utils.isSystemWin);
                c = ConfigManager.createRnvConfig(program, process, cmd, subCmd);
                Logger.logInitialize();
                _a = global;
                return [4 /*yield*/, Promise.resolve().then(function () { return tslib_1.__importStar(require('node-fetch')); })];
            case 1:
                _a.fetch = _b.sent();
                global.Headers = global.fetch.Headers;
                return [2 /*return*/, c];
        }
    });
}); };
exports.initializeBuilder = initializeBuilder;
var run = function (cmd, subCmd, program, process) {
    (0, exports.initializeBuilder)(cmd, subCmd, process, program)
        .then(function (c) { return config_1.default.initializeConfig(c); })
        .then(function (c) { return (0, cli_1.default)(c); })
        .then(function () { return Logger.logComplete(!config_1.default.getConfig().runtime.keepSessionActive); })
        .catch(function (e) { return Logger.logError(e, true); });
};
exports.run = run;
exports.doResolve = Resolver.doResolve;
exports.doResolvePath = Resolver.doResolvePath;
exports.default = { run: run, Config: config_1.default };
//# sourceMappingURL=index.js.map